import { Injectable } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { MessageService } from "primeng/components/common/messageservice";
import { TranslateService } from "@ngx-translate/core";

import { BridgeDto } from "./bridge-dto";
import { EntityService } from "../../../shared/services/entity-service";


@Injectable()
export class BridgeService extends EntityService<BridgeDto> {

    constructor(protected http: HttpClient, protected messageService: MessageService, protected translate: TranslateService) {
        super(
            http,
            messageService,
            `hcm_clocking_event_foundation/general/entities/bridge`,
            `hcm_clocking_event_foundation/general/actions`,
            translate
        );
    }

}
