import { Injectable } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { MessageService } from "primeng/components/common/messageservice";
import { TranslateService } from "@ngx-translate/core";

import { EntityService, ListParams } from "../../../shared/services/entity-service";
import { E001PesDto } from "./e-001-pes-dto";

@Injectable()
export class E001PesService extends EntityService<E001PesDto> {
    constructor(protected http: HttpClient, protected messageService: MessageService, protected translate: TranslateService) {
        super(
            http,
            messageService,
            `hcm_clocking_event_foundation/general/entities/e001pes`,
            `hcm_clocking_event_foundation/general/actions`,
            translate
        );
    }

    public listExternalE001Pes(listParams: ListParams) {
        return this.http
            .get<E001PesDto>("erpx_fnd/pessoa/entities/e001pes", {
                params: this.getListQueryParams(listParams),
            })
            .pipe(this.defaultCatch());
    }

}
