import * as moment_ from "moment";
import { E001PesDto } from "./e-001-pes-dto";

const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670

export class E001Pes {
    public id?: string;
    public nomPes: string;
    public excluido?: boolean = false;
    public extIntSts?: string;
    public extIntMsg?: string;
    public createdBy?: string;
    public createdDate?: Date;
    public lastModifiedBy?: string;
    public lastModifiedDate?: Date;
    public custom?: any;

    public static fromDto(e001PesDto: E001PesDto, originEntity?: string): E001Pes {
        const model: any = { ...e001PesDto };

        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();

        const lookupSeparator = " - ";
        const displayFields = ["nomPes"];

        model.label = displayFields.map(field => model[field]).join(lookupSeparator);

        return model as E001Pes;
    }

    public static toDto(e001Pes: E001Pes, originEntity?: string): E001PesDto {
        const dto: any = { ...e001Pes };

        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();

        delete dto.label;

        return dto;
    }

}