import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { TranslateService } from "@ngx-translate/core";
import { MessageService } from "primeng/components/common/messageservice";
import { EntityService, ListParams } from "../../../shared/services/entity-service";

import { EmployeeDto } from "./employee-dto";

@Injectable()
export class EmployeeService extends EntityService<EmployeeDto> {

    constructor(protected http: HttpClient, protected messageService: MessageService, protected translate: TranslateService) {
        super(
            http,
            messageService,
            `hcm_contract/employment_contract/entities/employee`,
            `hcm_contract/employment_contract/actions`,
            translate
        );
    }

    public listExternalEmployee(listParams: ListParams) {
        return this.http
            .get<EmployeeDto>("hcm_contract/employment_contract/entities/employee", {
                params: this.getListQueryParams(listParams),
            })
            .pipe(this.defaultCatch());
    }

}
