import * as moment_ from "moment";
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/

import { SituationClockingEventDto } from "./situation-clocking-event-dto";
import { Situation } from "../situation/situation";
/*{CA:PROJECT_IMPORTS:START}*/
const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PROJECT_IMPORTS:END}*/

export class SituationClockingEvent {
    public id?: string;
    public situation?: Situation;
    public complementarySituation?: Situation;
    public exceptionSituation?: boolean;
    public mandatoryAdjustmentReason?: boolean;
    public daytimeSituation: boolean = false;
    public convertNightHours?: boolean;
    public obligateAttachmentOnLeave?: boolean;
    public createdBy?: string;
    public createdDate?: Date;
    public lastModifiedBy?: string;
    public lastModifiedDate?: Date;
    public custom?: any;
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/

    public static fromDto(situationClockingEventDto: SituationClockingEventDto, originEntity?: string): SituationClockingEvent {
        const model: any = { ...situationClockingEventDto };

        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();

        const lookupSeparator = " - ";
        const displayFields = [
            "id",
            "complementarySituation.code",
            "complementarySituation.name",
            "exceptionSituation",
            "mandatoryAdjustmentReason",
            "daytimeSituation",
            "convertNightHours",
            "obligateAttachmentOnLeave",
            "createdBy",
            "createdDate",
            "lastModifiedBy",
            "lastModifiedDate",
        ];

        model.label = displayFields.map(field => model[field]).join(lookupSeparator);

        if (originEntity !== "Situation" && model.situation) model.situation = Situation.fromDto(model.situation, "SituationClockingEvent");
        if (originEntity !== "Situation" && model.complementarySituation)
            model.complementarySituation = Situation.fromDto(model.complementarySituation, "SituationClockingEvent");

        return model as SituationClockingEvent;
    }

    public static toDto(situationClockingEvent: SituationClockingEvent, originEntity?: string): SituationClockingEventDto {
        const dto: any = { ...situationClockingEvent };

        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();

        delete dto.label;

        if (originEntity !== "Situation" && dto.situation) dto.situation = Situation.toDto(dto.situation, "SituationClockingEvent");
        if (originEntity !== "Situation" && dto.complementarySituation)
            dto.complementarySituation = Situation.toDto(dto.complementarySituation, "SituationClockingEvent");

        return dto;
    }

    /*{CA:CLASS_METHODS:START}*/
    /*{CA:CLASS_METHODS:END}*/
}

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
