import * as moment_ from "moment";
import { SituationDto } from "./situation-dto";
/*{CA:PACKAGE_IMPORTS:START}*/
const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/


export class Situation {
    public id?: string;
    public code: number;
    public name: string;
    public deleted?: boolean = false;
    public extIntSts?: string;
    public extIntMsg?: string;
    public createdBy?: string;
    public createdDate?: Date;
    public lastModifiedBy?: string;
    public lastModifiedDate?: Date;
    public custom?: any;
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/

    public static fromDto(situationDto: SituationDto, originEntity?: string): Situation {
        const model: any = { ...situationDto };

        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();

        const lookupSeparator = " - ";
        const displayFields = ["code", "name"];

        model.label = displayFields.map(field => model[field]).join(lookupSeparator);

        return model as Situation;
    }

    public static toDto(situation: Situation, originEntity?: string): SituationDto {
        const dto: any = { ...situation };

        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();

        delete dto.label;

        return dto;
    }

    /*{CA:CLASS_METHODS:START}*/
    /*{CA:CLASS_METHODS:END}*/
}

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
