import * as moment_ from "moment";
/*{CA:PACKAGE_IMPORTS:START}*/
const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/

import { TimeEvaluationSituationDefinitionHistoryDto } from "./time-evaluation-situation-definition-history-dto";
import { TimeEvaluationSituationDefinition } from "../time-evaluation-situation-definition";
import { SituationClockingEvent } from "../situation-clocking-event/situation-clocking-event";
import { convertMinutesToTime, convertTimeToMinutes } from "../../../shared/utils/utils";
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/

export class TimeEvaluationSituationDefinitionHistory {
    public id?: string;
    public situationDefinition: TimeEvaluationSituationDefinition;
    public startDate: Date;
    public endDate?: Date;
    public workSituation?: SituationClockingEvent;
    public nightShiftWorkPremium?: SituationClockingEvent;
    public invalidEventsSituation?: SituationClockingEvent;
    public vacationPaidLeaveSituation?: SituationClockingEvent;
    public dailyRestViolationSituation?: SituationClockingEvent;
    public workBreakViolationSituation?: SituationClockingEvent;
    public absenceSituation?: SituationClockingEvent;
    public tardinessSituation?: SituationClockingEvent;
    public intermediateLeaveSituation?: SituationClockingEvent;
    public earlyLeaveSituation?: SituationClockingEvent;
    public absenceSituationOnRelayScheduleHolidays?: SituationClockingEvent;
    public percentageNextDay?: boolean;
    public normalOvertimeSeparationLimit?: number;
    public separateOvertimeAfterConvertingNightShiftHours?: boolean;
    public unauthorizedOvertime?: SituationClockingEvent;
    public overtimeBefore?: SituationClockingEvent;
    public overtimeEntry?: SituationClockingEvent;
    public overtimeDuringMeal?: SituationClockingEvent;
    public leaveOvertime?: SituationClockingEvent;
    public overtimeAfter?: SituationClockingEvent;
    public overtimeSeparationLimitDuringRest?: number;
    public overtimeDuringRest?: SituationClockingEvent;
    public overtimeSeparationLimitDuringCompensatedDays?: number;
    public overtimeOnCompensatedDays?: SituationClockingEvent;
    public overtimeSeparationLimitDuringHoliday?: number;
    public overtimeDuringHoliday?: SituationClockingEvent;
    public overtimeSeparationLimitDuringDayOff?: number;
    public overtimeDuringDayOff?: SituationClockingEvent;
    public overtimeSituationOnRelayScheduleHolidays?: SituationClockingEvent;
    public nightShiftOvertimePremiumSituation?: SituationClockingEvent;
    public overtimeSeparationBefore?: SituationClockingEvent;
    public overtimeSeparationEntry?: SituationClockingEvent;
    public overtimeSeparationDuringMeal?: SituationClockingEvent;
    public overtimeSeparationLeave?: SituationClockingEvent;
    public overtimeSeparationAfter?: SituationClockingEvent;
    public overtimeSeparationDuringRest?: SituationClockingEvent;
    public overtimeSeparationDuringCompensatedDays?: SituationClockingEvent;
    public overtimeSeparationDuringHoliday?: SituationClockingEvent;
    public overtimeSeparationDuringDayOff?: SituationClockingEvent;
    public createdBy?: string;
    public createdDate?: Date;
    public lastModifiedBy?: string;
    public lastModifiedDate?: Date;
    public custom?: any;
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/

    public static fromDto(
        timeEvaluationSituationDefinitionHistoryDto: TimeEvaluationSituationDefinitionHistoryDto,
        originEntity?: string
    ): TimeEvaluationSituationDefinitionHistory {
        const model: any = { ...timeEvaluationSituationDefinitionHistoryDto };

        model.startDate = model.startDate && moment(model.startDate).toDate();
        model.endDate = model.endDate && moment(model.endDate).toDate();
        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();

        if (model.normalOvertimeSeparationLimit && model.normalOvertimeSeparationLimit !== undefined) {
            model.normalOvertimeSeparationLimit = convertMinutesToTime(model.normalOvertimeSeparationLimit.toString());
        }

        if (model.overtimeSeparationLimitDuringRest && model.normalOvertimeSeparationLimit !== undefined) {
            model.overtimeSeparationLimitDuringRest = convertMinutesToTime(model.overtimeSeparationLimitDuringRest.toString());
        }

        if (model.overtimeSeparationLimitDuringCompensatedDays && model.overtimeSeparationLimitDuringCompensatedDays !== undefined) {
            model.overtimeSeparationLimitDuringCompensatedDays = convertMinutesToTime(model.overtimeSeparationLimitDuringCompensatedDays.toString());
        }

        if (model.overtimeSeparationLimitDuringHoliday && model.overtimeSeparationLimitDuringHoliday !== undefined) {
            model.overtimeSeparationLimitDuringHoliday = convertMinutesToTime(model.overtimeSeparationLimitDuringHoliday.toString());
        }

        if (model.overtimeSeparationLimitDuringDayOff && model.overtimeSeparationLimitDuringDayOff !== undefined) {
            model.overtimeSeparationLimitDuringDayOff = convertMinutesToTime(model.overtimeSeparationLimitDuringDayOff.toString());
        }

        const lookupSeparator = " - ";
        const displayFields = ["situationDefinition.code", "situationDefinition.name", "startDate", "endDate"];

        model.label = displayFields.map(field => model[field]).join(lookupSeparator);

        if (originEntity !== "TimeEvaluationSituationDefinition" && model.situationDefinition)
            model.situationDefinition = TimeEvaluationSituationDefinition.fromDto(
                model.situationDefinition,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.workSituation)
            model.workSituation = SituationClockingEvent.fromDto(model.workSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.nightShiftWorkPremium)
            model.nightShiftWorkPremium = SituationClockingEvent.fromDto(
                model.nightShiftWorkPremium,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.invalidEventsSituation)
            model.invalidEventsSituation = SituationClockingEvent.fromDto(
                model.invalidEventsSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.vacationPaidLeaveSituation)
            model.vacationPaidLeaveSituation = SituationClockingEvent.fromDto(
                model.vacationPaidLeaveSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.dailyRestViolationSituation)
            model.dailyRestViolationSituation = SituationClockingEvent.fromDto(
                model.dailyRestViolationSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.workBreakViolationSituation)
            model.workBreakViolationSituation = SituationClockingEvent.fromDto(
                model.workBreakViolationSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        
        if (originEntity !== "SituationClockingEvent" && model.absenceSituation)
            model.absenceSituation = SituationClockingEvent.fromDto(model.absenceSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.tardinessSituation)
            model.tardinessSituation = SituationClockingEvent.fromDto(model.tardinessSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.intermediateLeaveSituation)
            model.intermediateLeaveSituation = SituationClockingEvent.fromDto(
                model.intermediateLeaveSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.earlyLeaveSituation)
            model.earlyLeaveSituation = SituationClockingEvent.fromDto(
                model.earlyLeaveSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.absenceSituationOnRelayScheduleHolidays)
            model.absenceSituationOnRelayScheduleHolidays = SituationClockingEvent.fromDto(
                model.absenceSituationOnRelayScheduleHolidays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.unauthorizedOvertime)
            model.unauthorizedOvertime = SituationClockingEvent.fromDto(
                model.unauthorizedOvertime,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeBefore)
            model.overtimeBefore = SituationClockingEvent.fromDto(model.overtimeBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeEntry)
            model.overtimeEntry = SituationClockingEvent.fromDto(model.overtimeEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringMeal)
            model.overtimeDuringMeal = SituationClockingEvent.fromDto(model.overtimeDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.leaveOvertime)
            model.leaveOvertime = SituationClockingEvent.fromDto(model.leaveOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeAfter)
            model.overtimeAfter = SituationClockingEvent.fromDto(model.overtimeAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringRest)
            model.overtimeDuringRest = SituationClockingEvent.fromDto(model.overtimeDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && model.overtimeOnCompensatedDays)
            model.overtimeOnCompensatedDays = SituationClockingEvent.fromDto(
                model.overtimeOnCompensatedDays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringHoliday)
            model.overtimeDuringHoliday = SituationClockingEvent.fromDto(
                model.overtimeDuringHoliday,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeDuringDayOff)
            model.overtimeDuringDayOff = SituationClockingEvent.fromDto(
                model.overtimeDuringDayOff,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSituationOnRelayScheduleHolidays)
            model.overtimeSituationOnRelayScheduleHolidays = SituationClockingEvent.fromDto(
                model.overtimeSituationOnRelayScheduleHolidays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.nightShiftOvertimePremiumSituation)
            model.nightShiftOvertimePremiumSituation = SituationClockingEvent.fromDto(
                model.nightShiftOvertimePremiumSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationBefore)
            model.overtimeSeparationBefore = SituationClockingEvent.fromDto(
                model.overtimeSeparationBefore,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationEntry)
            model.overtimeSeparationEntry = SituationClockingEvent.fromDto(
                model.overtimeSeparationEntry,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringMeal)
            model.overtimeSeparationDuringMeal = SituationClockingEvent.fromDto(
                model.overtimeSeparationDuringMeal,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationLeave)
            model.overtimeSeparationLeave = SituationClockingEvent.fromDto(
                model.overtimeSeparationLeave,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationAfter)
            model.overtimeSeparationAfter = SituationClockingEvent.fromDto(
                model.overtimeSeparationAfter,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringRest)
            model.overtimeSeparationDuringRest = SituationClockingEvent.fromDto(
                model.overtimeSeparationDuringRest,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringCompensatedDays)
            model.overtimeSeparationDuringCompensatedDays = SituationClockingEvent.fromDto(
                model.overtimeSeparationDuringCompensatedDays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringHoliday)
            model.overtimeSeparationDuringHoliday = SituationClockingEvent.fromDto(
                model.overtimeSeparationDuringHoliday,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && model.overtimeSeparationDuringDayOff)
            model.overtimeSeparationDuringDayOff = SituationClockingEvent.fromDto(
                model.overtimeSeparationDuringDayOff,
                "TimeEvaluationSituationDefinitionHistory"
            );

        return model as TimeEvaluationSituationDefinitionHistory;
    }

    public static toDto(
        timeEvaluationSituationDefinitionHistory: TimeEvaluationSituationDefinitionHistory,
        originEntity?: string
    ): TimeEvaluationSituationDefinitionHistoryDto {
        const dto: any = { ...timeEvaluationSituationDefinitionHistory };

        if (dto.normalOvertimeSeparationLimit && dto.normalOvertimeSeparationLimit !== undefined) {
            dto.normalOvertimeSeparationLimit = convertTimeToMinutes(dto.normalOvertimeSeparationLimit);
        }

        if (dto.overtimeSeparationLimitDuringRest && dto.overtimeSeparationLimitDuringRest !== undefined) {
            dto.overtimeSeparationLimitDuringRest = convertTimeToMinutes(dto.overtimeSeparationLimitDuringRest);
        }

        if (dto.overtimeSeparationLimitDuringCompensatedDays && dto.overtimeSeparationLimitDuringCompensatedDays !== undefined) {
            dto.overtimeSeparationLimitDuringCompensatedDays = convertTimeToMinutes(dto.overtimeSeparationLimitDuringCompensatedDays);
        }

        if (dto.overtimeSeparationLimitDuringHoliday && dto.overtimeSeparationLimitDuringHoliday !== undefined) {
            dto.overtimeSeparationLimitDuringHoliday = convertTimeToMinutes(dto.overtimeSeparationLimitDuringHoliday);
        }

        if (dto.overtimeSeparationLimitDuringDayOff && dto.overtimeSeparationLimitDuringDayOff !== undefined) {
            dto.overtimeSeparationLimitDuringDayOff = convertTimeToMinutes(dto.overtimeSeparationLimitDuringDayOff);
        }


        dto.startDate = dto.startDate && moment(dto.startDate).format("YYYY-MM-DD");
        dto.endDate = dto.endDate && moment(dto.endDate).format("YYYY-MM-DD");
        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();

        delete dto.label;

        if (originEntity !== "TimeEvaluationSituationDefinition" && dto.situationDefinition)
            dto.situationDefinition = TimeEvaluationSituationDefinition.toDto(
                dto.situationDefinition,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.workSituation)
            dto.workSituation = SituationClockingEvent.toDto(dto.workSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.nightShiftWorkPremium)
            dto.nightShiftWorkPremium = SituationClockingEvent.toDto(dto.nightShiftWorkPremium, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.invalidEventsSituation)
            dto.invalidEventsSituation = SituationClockingEvent.toDto(
                dto.invalidEventsSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.vacationPaidLeaveSituation)
            dto.vacationPaidLeaveSituation = SituationClockingEvent.toDto(
                dto.vacationPaidLeaveSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.dailyRestViolationSituation)
            dto.dailyRestViolationSituation = SituationClockingEvent.toDto(
                dto.dailyRestViolationSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.workBreakViolationSituation)
            dto.workBreakViolationSituation = SituationClockingEvent.toDto(
                dto.workBreakViolationSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        
        if (originEntity !== "SituationClockingEvent" && dto.absenceSituation)
            dto.absenceSituation = SituationClockingEvent.toDto(dto.absenceSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.tardinessSituation)
            dto.tardinessSituation = SituationClockingEvent.toDto(dto.tardinessSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.intermediateLeaveSituation)
            dto.intermediateLeaveSituation = SituationClockingEvent.toDto(
                dto.intermediateLeaveSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.earlyLeaveSituation)
            dto.earlyLeaveSituation = SituationClockingEvent.toDto(dto.earlyLeaveSituation, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.absenceSituationOnRelayScheduleHolidays)
            dto.absenceSituationOnRelayScheduleHolidays = SituationClockingEvent.toDto(
                dto.absenceSituationOnRelayScheduleHolidays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.unauthorizedOvertime)
            dto.unauthorizedOvertime = SituationClockingEvent.toDto(dto.unauthorizedOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeBefore)
            dto.overtimeBefore = SituationClockingEvent.toDto(dto.overtimeBefore, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeEntry)
            dto.overtimeEntry = SituationClockingEvent.toDto(dto.overtimeEntry, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringMeal)
            dto.overtimeDuringMeal = SituationClockingEvent.toDto(dto.overtimeDuringMeal, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.leaveOvertime)
            dto.leaveOvertime = SituationClockingEvent.toDto(dto.leaveOvertime, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeAfter)
            dto.overtimeAfter = SituationClockingEvent.toDto(dto.overtimeAfter, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringRest)
            dto.overtimeDuringRest = SituationClockingEvent.toDto(dto.overtimeDuringRest, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeOnCompensatedDays)
            dto.overtimeOnCompensatedDays = SituationClockingEvent.toDto(
                dto.overtimeOnCompensatedDays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringHoliday)
            dto.overtimeDuringHoliday = SituationClockingEvent.toDto(dto.overtimeDuringHoliday, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeDuringDayOff)
            dto.overtimeDuringDayOff = SituationClockingEvent.toDto(dto.overtimeDuringDayOff, "TimeEvaluationSituationDefinitionHistory");
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSituationOnRelayScheduleHolidays)
            dto.overtimeSituationOnRelayScheduleHolidays = SituationClockingEvent.toDto(
                dto.overtimeSituationOnRelayScheduleHolidays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.nightShiftOvertimePremiumSituation)
            dto.nightShiftOvertimePremiumSituation = SituationClockingEvent.toDto(
                dto.nightShiftOvertimePremiumSituation,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationBefore)
            dto.overtimeSeparationBefore = SituationClockingEvent.toDto(
                dto.overtimeSeparationBefore,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationEntry)
            dto.overtimeSeparationEntry = SituationClockingEvent.toDto(
                dto.overtimeSeparationEntry,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringMeal)
            dto.overtimeSeparationDuringMeal = SituationClockingEvent.toDto(
                dto.overtimeSeparationDuringMeal,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationLeave)
            dto.overtimeSeparationLeave = SituationClockingEvent.toDto(
                dto.overtimeSeparationLeave,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationAfter)
            dto.overtimeSeparationAfter = SituationClockingEvent.toDto(
                dto.overtimeSeparationAfter,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringRest)
            dto.overtimeSeparationDuringRest = SituationClockingEvent.toDto(
                dto.overtimeSeparationDuringRest,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringCompensatedDays)
            dto.overtimeSeparationDuringCompensatedDays = SituationClockingEvent.toDto(
                dto.overtimeSeparationDuringCompensatedDays,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringHoliday)
            dto.overtimeSeparationDuringHoliday = SituationClockingEvent.toDto(
                dto.overtimeSeparationDuringHoliday,
                "TimeEvaluationSituationDefinitionHistory"
            );
        if (originEntity !== "SituationClockingEvent" && dto.overtimeSeparationDuringDayOff)
            dto.overtimeSeparationDuringDayOff = SituationClockingEvent.toDto(
                dto.overtimeSeparationDuringDayOff,
                "TimeEvaluationSituationDefinitionHistory"
            );

        return dto;
    }

    /*{CA:CLASS_METHODS:START}*/
    /*{CA:CLASS_METHODS:END}*/
}

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
