import { HttpClient } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { TranslateService } from "@ngx-translate/core";
import { MessageService } from "primeng/components/common/messageservice";
/*{CA:PACKAGE_IMPORTS:START}*/
/*{CA:PACKAGE_IMPORTS:END}*/

import { EntityService, ListParams } from "../../../shared/services/entity-service";
import { TimeEvaluationSituationDefinitionHistoryDto } from "../time-evaluation-situation-definition-history/time-evaluation-situation-definition-history-dto";
import { TimeEvaluationSituationDefinitionDto } from "./time-evaluation-situation-definition-dto";
/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/

@Injectable()
export class TimeEvaluationSituationDefinitionService extends EntityService<TimeEvaluationSituationDefinitionDto> {
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/

    constructor(protected http: HttpClient, protected messageService: MessageService, protected translate: TranslateService) {
        super(
            http,
            messageService,
            `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinition`,
            `hcm_clocking_event_foundation/general/actions`,
            translate
        );
        /*{CA:CONSTRUCTOR_END:START}*/
        /*{CA:CONSTRUCTOR_END:END}*/
    }

    public getTimeEvaluationSituationDefinitionHistory(timeEvaluationSituationDefinitionId: any, id: any) {
        return this.http
            .get<TimeEvaluationSituationDefinitionHistoryDto>(
                `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/${id}`
            )
            .pipe(this.defaultCatch());
    }

    public updateTimeEvaluationSituationDefinitionHistory(
        timeEvaluationSituationDefinitionId: any,
        id: any,
        timeEvaluationSituationDefinitionHistoryDto: TimeEvaluationSituationDefinitionHistoryDto
    ) {
        return this.http
            .put<TimeEvaluationSituationDefinitionHistoryDto>(
                `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/${id}`,
                timeEvaluationSituationDefinitionHistoryDto
            )
            .pipe(this.defaultCatch());
    }

    public listTimeEvaluationSituationDefinitionHistory(timeEvaluationSituationDefinitionId: any, listParams: ListParams) {
        return this.http
            .get<TimeEvaluationSituationDefinitionHistoryDto[]>(
                `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory`,
                { params: this.getListQueryParams(listParams) }
            )
            .pipe(this.defaultCatch());
    }

    public insertTimeEvaluationSituationDefinitionHistory(timeEvaluationSituationDefinitionId: any,
        timeEvaluationSituationDefinitionHistoryDto: TimeEvaluationSituationDefinitionHistoryDto) {
        return this.http
            .post<TimeEvaluationSituationDefinitionHistoryDto>(
                `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory`,
                timeEvaluationSituationDefinitionHistoryDto
            )
            .pipe(this.defaultCatch());
    }

    public deleteTimeEvaluationSituationDefinitionHistory(timeEvaluationSituationDefinitionId: any, id: any) {
        return this.http
            .delete<TimeEvaluationSituationDefinitionHistoryDto>(
                `hcm_clocking_event_foundation/general/entities/timeEvaluationSituationDefinitionHistory/${id}`
            )
            .pipe(this.defaultCatch());
    }

}

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
