import * as moment_ from "moment";
import { TimeEvaluationSituationDefinitionDto } from "./time-evaluation-situation-definition-dto";
/*{CA:PACKAGE_IMPORTS:START}*/
const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670
/*{CA:PACKAGE_IMPORTS:END}*/


export class TimeEvaluationSituationDefinition {
    public id?: string;
    public code: number;
    public name: string;
    public createdBy?: string;
    public createdDate?: Date;
    public lastModifiedBy?: string;
    public lastModifiedDate?: Date;
    public custom?: any;
    /*{CA:CLASS_ATTRIBUTES:START}*/
    /*{CA:CLASS_ATTRIBUTES:END}*/

    public static fromDto(timeEvaluationSituationDefinitionDto: TimeEvaluationSituationDefinitionDto, originEntity?: string): TimeEvaluationSituationDefinition {
        const model: any = { ...timeEvaluationSituationDefinitionDto };

        model.createdDate = model.createdDate && moment(model.createdDate).toDate();
        model.lastModifiedDate = model.lastModifiedDate && moment(model.lastModifiedDate).toDate();

        const lookupSeparator = " - ";
        const displayFields = ["code", "name"];

        model.label = displayFields.map(field => model[field]).join(lookupSeparator);

        return model as TimeEvaluationSituationDefinition;
    }

    public static toDto(timeEvaluationSituationDefinition: TimeEvaluationSituationDefinition, originEntity?: string): TimeEvaluationSituationDefinitionDto {
        const dto: any = { ...timeEvaluationSituationDefinition };

        dto.createdDate = dto.createdDate && moment(dto.createdDate).format();
        dto.lastModifiedDate = dto.lastModifiedDate && moment(dto.lastModifiedDate).format();

        delete dto.label;

        return dto;
    }

    /*{CA:CLASS_METHODS:START}*/
    /*{CA:CLASS_METHODS:END}*/
}

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
