import { CommonModule } from "@angular/common";
import { NgModule } from "@angular/core";
import { FormsModule, ReactiveFormsModule } from "@angular/forms";
import { TranslateModule } from "@ngx-translate/core";
import { ButtonModule, ControlErrorsModule, CustomFieldsModule, DynamicFormModule, EmptyStateModule, LoadingStateModule } from "@seniorsistemas/angular-components";
import { HotkeyModule } from "angular2-hotkeys";
import { CurrencyMaskModule } from "ng2-currency-mask";
import { CalendarModule } from "primeng/calendar";
import { ConfirmDialogModule } from "primeng/confirmdialog";
import { InputTextModule } from "primeng/inputtext";
import { MessagesModule } from "primeng/messages";
import { PanelModule } from "primeng/panel";
import { SharedModule } from "primeng/shared";
import { SplitButtonModule } from "primeng/splitbutton";
/*{CA:PACKAGE_IMPORTS:START}*/
import { FocusService } from "./focus/focus.service";
import { FieldCustomizationService } from "./services/field-customization.service";
import { FiltersStorageService } from "./storage/filters-storage.service";
import { PaginatorStorageService } from "./storage/paginator-storage.service";
/*{CA:PACKAGE_IMPORTS:END}*/

/*{CA:PROJECT_IMPORTS:START}*/
/*{CA:PROJECT_IMPORTS:END}*/

@NgModule({
    imports: [
        /*{CA:MODULE_IMPORTS:START}*/
        SplitButtonModule,
        MessagesModule,
        FormsModule,
        ReactiveFormsModule,
        CommonModule,
        CurrencyMaskModule,
        TranslateModule,
        CustomFieldsModule,
        ControlErrorsModule,
        EmptyStateModule,
        DynamicFormModule,
        PanelModule,
        InputTextModule,
        ButtonModule,
        ConfirmDialogModule,
        CalendarModule,
        SharedModule,
        HotkeyModule,
        LoadingStateModule,
        /*{CA:MODULE_IMPORTS:END}*/
    ],
    providers: [
        FiltersStorageService,
        PaginatorStorageService,
        FocusService,
        FieldCustomizationService,
        /*{CA:MODULE_PROVIDERS:START}*/
        /*{CA:MODULE_PROVIDERS:END}*/
    ],
    declarations: [
        /*{CA:MODULE_DECLARATIONS:START}*/
        /*{CA:MODULE_DECLARATIONS:END}*/
    ],
    /*{CA:MODULE_CONFIG:START}*/
    exports: [
        SplitButtonModule,
        MessagesModule,
        FormsModule,
        ReactiveFormsModule,
        CommonModule,
        CurrencyMaskModule,
        TranslateModule,
        CustomFieldsModule,
        ControlErrorsModule,
        EmptyStateModule,
        DynamicFormModule,
        PanelModule,
        InputTextModule,
        ButtonModule,
        ConfirmDialogModule,
        CalendarModule,
        SharedModule,
        HotkeyModule,
        LoadingStateModule
    ]
    /*{CA:MODULE_CONFIG:END}*/
})
export class SharedScheduleModule { }

/*{CA:FILE_CONTENTS:START}*/
/*{CA:FILE_CONTENTS:END}*/
