import { FieldType } from "@seniorsistemas/angular-components";
import * as moment_ from "moment";

const moment = moment_; // @HACK Necessary because of https://github.com/rollup/rollup/issues/670

export function mapLookupFilterQuery(value: any, type: any, name: any) {
    if (typeof value == "number") return `${name} eq ${value}`;
    else if (type == FieldType.Date) return `${name} eq '${moment(value).format("YYYY-MM-DD")}'`;
    else if (type == FieldType.Time) return `${name} eq '${moment(value).format("HH:mm:ss")}'`;
    else if (type == FieldType.DateTime) return `${name} eq '${moment(value).format()}'`;
    else if (type == FieldType.Enum) return `${name} eq '${value}'`;
    else if (type == FieldType.String) return `containing(upper(${name}), upper('${value.replace(/'/g, "\\'")}'))`;
    else return `${name} eq '${value}'`;
}

export function getProp(obj: any, path: any) {
    return path.split(".").reduce((result: any, prop: any) => (result[prop] === undefined ? "" : result[prop]), obj);
}

export function toRecordsFoundLabel(value: number): string {
    if (value === 1) {
        return 'hcm_clocking_event_foundation.general.generic_record_found';
    } else if (value && value > 1) {
        return 'hcm_clocking_event_foundation.general.generic_n_records_found';
    } else {
        return 'hcm_clocking_event_foundation.general.generic_no_records_found';
    }
}