import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { BrowserAnimationsModule } from "@angular/platform-browser/animations";
import { RouterModule } from "@angular/router";
import { TranslateModule } from "@ngx-translate/core";
import { ButtonModule, LocaleModule } from "@seniorsistemas/angular-components";
import {
    CyclicJsonInterceptorModule,
    HttpInterceptorModule, PermissionsModule,
    TranslationsModule
} from "@seniorsistemas/platform-components";
import { HotkeyModule } from "angular2-hotkeys";
import { MessageService } from "primeng/api";
import { ToastModule } from "primeng/toast";
import { AppComponent } from "./app.component";
import { BridgeShowcaseModule } from "./components/bridge-showcase/bridge-showcase.module";

@NgModule({
    declarations: [
        AppComponent,
    ],
    imports: [
        LocaleModule.forRoot(),
        TranslateModule.forRoot(),
        TranslationsModule.forRoot([]),
        BrowserModule,
        BrowserAnimationsModule,
        ButtonModule,
        RouterModule.forRoot([]),
        HttpInterceptorModule,
        HotkeyModule.forRoot(),
        CyclicJsonInterceptorModule,
        BridgeShowcaseModule,
        PermissionsModule.forRoot([], {ignorePermissions: false}),
        ToastModule,
    ],
    bootstrap: [AppComponent],
    providers: [
        MessageService
    ]
})
export class AppModule {
}
