import { Component, OnInit } from "@angular/core";
import { EmployeeDate } from "@senior-gestao-pessoas/hcm-clocking-event-foundation-schedules-histories";
import * as moment from "moment";
import { Subject } from "rxjs";

@Component({
    selector: "app-bridge",
    templateUrl: "./bridge-showcase.component.html",
})
export class BridgeShowcaseComponent implements OnInit {

    onSubmitSubject: Subject<any> = new Subject();
    schedule: string;
    lockedEmployee: EmployeeDate;
    lockedEmployeeSubject: Subject<EmployeeDate> = new Subject();
    scheduleName: string;
    visible: boolean = true;

    ngOnInit() {

        this.lockedEmployee = {
            employeeId: '92f38c8c-cdd3-461b-ad04-43711c48956b',
            evaluationDate: moment('2022-10-25').toDate()
        }

        this.lockedEmployeeSubject.next(this.lockedEmployee);
    }

    onSave() {
        this.onSubmitSubject.next(true);
    }

    onClose() {
        this.visible = false;
    }

    onShow() {
        this.visible = true;
    }

    changeDay(day: string) {
        this.lockedEmployeeSubject.next({
            employeeId: '92f38c8c-cdd3-461b-ad04-43711c48956b',
            evaluationDate: moment(`2022-10-${day}`).toDate()
        })
    }
}
