import { CommonModule } from "@angular/common";
import { NgModule } from "@angular/core";
import { ButtonModule } from "primeng/button";

import { TranslateModule } from "@ngx-translate/core";
import { BridgeFormModule } from "@senior-gestao-pessoas/hcm-clocking-event-foundation-schedules-histories";
import { LocaleService } from "@seniorsistemas/angular-components";
import {
    FeatureToggleModule, TranslationsModule
} from "@seniorsistemas/platform-components";
import { fallback } from "../../../locale/fallback";
import { BridgeShowcaseRoutingModule } from "./bridge-showcase-routing.module";
import { BridgeShowcaseComponent } from "./bridge-showcase.component";

@NgModule({
    imports: [
        CommonModule,
        BridgeShowcaseRoutingModule,
        ButtonModule,
        BridgeFormModule,
        TranslateModule,
        FeatureToggleModule,
        TranslationsModule.forChild([
            {
                domain: "hcm_clocking_event_foundation",
                service: "general",
                fallback: fallback["default"] || fallback
            },
        ])
    ],
    declarations: [BridgeShowcaseComponent],
    providers: [
        LocaleService
    ]
})
export class BridgeShowcaseModule {
}
